-- User: Krakyn
-- Created: 11/30/2015 5:58 PM

Bam = LibStub('AceAddon-3.0'):NewAddon('Bam', 'AceConsole-3.0', 'AceEvent-3.0')
local B = _G.Bam
local guid = UnitGUID("player")
local THISVER, FIRSTRUN, FIXDB = 60200, false, false
local defaults = {
  lastver = THISVER,
  enabled = false,
  bam_string = 'BaM! \[%s - %d\]',
  bam_sound = '\\Interface\\Addons\\Bam\\bam.wav',
  channels = {
    ['PRINT'] = true,
    ['EMOTE'] = true,
    ['SAY'] = false,
    ['YELL'] = false,
    ['RAID'] = false,
    ['PARTY'] = false,
    ['INSTANCE_CHAT'] = false,
    ['BATTLEGROUND'] = false,
    ['RAID_WARNING'] = false,
    ['GUILD'] = false,
    ['OFFICER'] = false,
  }
}
local sound_bank = {
  ["Mcjiggs"] = "Sound\\Character\\PlayerExertions\\TaurenFemaleFinal\\TaurenFemaleFinalDeathA.wav",
  ["Bam!"] = "\\Interface\\Addons\\Bam\\bam.wav",
  ["Baaam"] = "\\Interface\\Addons\\Bam\\baaaam.wav",
  ["Crow"] = "\\Interface\\Addons\\Bam\\crow.mp3",
  ["Finish Him"] = "\\Interface\\Addons\\Bam\\finishhim.wav",
  ["Headshot"] = "\\Interface\\Addons\\Bam\\headshot.wav",
  ["Mouth Pop"] = "\\Interface\\Addons\\Bam\\mouthpop.wav",
  ["Tritt"] =  "\\Interface\\Addons\\Bam\\tritt.wav",
  ["Vollgas"] = "\\Interface\\Addons\\Bam\\vollgas.wav",
  ["Yeh Gurl"] = "\\Interface\\Addons\\Bam\\yehgurl.wav"
}

if (not BamDB) then
  FIXDB = true
elseif BamDB.lastver < THISVER then
  FIXDB = true
end

if  FIXDB == true then
  BamDB = {}
  for k,v in pairs(defaults) do
    BamDB[k] = v
    if type(v) == 'table' then
      for kk, vv in pairs(defaults[k]) do
        v[kk] = vv
      end
    end
  end
  FIRSTRUN = true
end

B.SoundOpt = function (self, opts)
  print(self, unpack(opts))
end

function B:OnInitialize()
  if FIRSTRUN then
    self:Print('This is probably your first time installing BaM or you lost the config table in the depths of your cavernous ass. Either way, type |cFFFFFF00/bam|r to begin. You will never see this message again.')
  end

  local db = _G.BamDB

  local opts = {
    type='group',
    name='BaM',
    set = function(info, value)
      local db = _G.BamDB
      if defaults[info[#info]] ~= value then
        db[info[#info]] = value
      end
    end,
    get = function(info)
      local db = _G.BamDB
      if not db[info[#info]] then
        return defaults[info[#info]]
      else
        return db[info[#info]]
      end
    end,

    args = {
      enabled = {
        type = 'toggle',
        name = 'Enable BaM outputs',
        order = 1,
        width = 'full',
      },
      bam_string = {
        type = 'input',
        name = 'BaM Format',
        order = 100,
        width = 'full'
      },
      bam_throttle = {
        type = 'range',
        name = 'Throttle',
        order = 200,
        min = 0,
        max = 60,
        softMax = 10,
        step = 0.1,
      },
      t_channels = {
        type = 'header',
        name = 'Outputs',
        order = 300,
      },
      c_say = B.ChannelOpt('SAY', 400),
      c_emote = B.ChannelOpt('EMOTE', 405),
      c_yell = B.ChannelOpt('YELL', 410),
      c_party = B.ChannelOpt('PARTY', 415),
      c_raid = B.ChannelOpt('RAID', 420),
      c_instance = B.ChannelOpt('INSTANCE_CHAT', 425),
      c_battleground = B.ChannelOpt('BATTLEGROUND', 430),
      c_raidwarning = B.ChannelOpt('RAID_WARNING', 435),
      c_guild = B.ChannelOpt('GUILD', 440),
      c_officer = B.ChannelOpt('OFFICER', 450),
      t_channels = {
        type = 'header',
        name = 'Custom Channel',
        order = 500,
      },
      custom_channel_enable = {
        type = 'toggle',
        name = 'Custom Channel',
        set = function(_, value)
          db.channels.CHANNEL = value
        end,
        get = function()
          return db.channels.CHANNEL
        end,
        order = 510,
        width = 'half',
      },
      custom_channel = {
        type = 'input',
        name = '',
        order = 515
      }
    }
  }



  LibStub("AceConfig-3.0"):RegisterOptionsTable("Bam", opts)
  self.BlizOptions = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Bam")
  self:RegisterChatCommand("bam", function() InterfaceOptionsFrame_OpenToCategory(self.BlizOptions) InterfaceOptionsFrame_OpenToCategory(self.BlizOptions) end)

  self:RegisterEvent('COMBAT_LOG_EVENT', 'OnCombatLogEvent')
  self:RegisterEvent('CHAT_MSG_CHANNEL_NOTICE', 'UpdateChannels')

  self:RegisterChatCommand("bamt", "BMark")
end

local c_names = {
  ['PRINT'] = 'Self',
  ['SAY'] = 'Say',
  ['EMOTE'] = 'Emote',
  ['YELL'] = 'Yell',
  ['PARTY'] = 'Party (/p)',
  ['RAID'] = 'Raid (/ra)',
  ['RAID_WARNING'] = 'Raid Warning (/rw)',
  ['GUILD'] = 'Guild (/g)',
  ['OFFICER'] = 'Officer (/o)',
  ['INSTANCE_CHAT'] = 'Instance (/i)',
  ['BATTLEGROUND'] = 'Battleground (/bg)',
  ['CHANNEL'] = 'Chat Channel (name or number)',
}
function B.ChannelOpt(chat_type, order)
  return {
    type = 'toggle',
    name = c_names[chat_type],
    set = function(info, value)
      BamDB.channels[chat_type] = value
    end,
    get = function(info)
      return BamDB.channels.value
    end,
    order = order
  }
end

function B:UpdateChannels(_, ...)
  local _, _, _, _, _, _, _, c_number, c_name = ...
  B.active_chats = {}
  local a = B.active_chats
  local channels = {GetChannelList() }
  for i,v in ipairs(channels) do
    a[i] = true
    a[v] = true
  end
end

function B:OnCombatLogEvent(e, ...)
  local amt, overkill, _, _, bl, abs, critical = ...
  if (critical == 1) then
      self:Bam(amt)
  end
end

function B:Bam(amt, spell)

  local db = _G.BamDB
  bam_msg = db.bam_string
  string.gsub(bam_msg, '%s', spell)
  string.gsub(bam_msg, '%a', amt)
  PlaySoundFile(_G.BamDB.bam_sound)
  for chat_type, enabled in pairs(BamDB.channels) do
    if enabled == true then
      if chat_type == 'PRINT' then
        print(bam_msg)
      else
        if chat_type == 'CHANNEL' then
          channel = db.custom_channel
        else
          channel = nil
        end

        SendChatMessage(bam_msg, chat_type, nil, channel)
      end
    end
end

function B:BMark()

  local a = GetTime()
  print('starting benchmark @', a)
  for i = 1, 250 do
    self:OnCLE('SPELL_DAMAGE', 12000, 123, 4, 0, 0, 0, 1)
    self:OnCLE('SPELL_PERIODIC_DAMAGE', 12000, 123, 4, 0, 0, 0, 1)
    self:OnCLE('SWING_DAMAGE', 12000, 123, 4, 0, 0, 0, 1)
    self:OnCLE('RANGE_DAMAGE', 12000, 123, 4, 0, 0, 0, 1)
  end
  a = GetTime() - a
  print('string match time: ', a)

  a = GetTime()
  print('starting benchmark @', a)
  for i = 1, 250 do
    self:OnCLE('SPELL_DAMAGE', 12000, 123, 4, 0, 0, 0, 1)
    self:OnCLE('SPELL_PERIODIC_DAMAGE', 12000, 123, 4, 0, 0, 0, 1)
    self:OnCLE('SWING_DAMAGE', 12000, 123, 4, 0, 0, 0, 1)
    self:OnCLE('RANGE_DAMAGE', 12000, 123, 4, 0, 0, 0, 1)
  end
  a = GetTime() - a
  print('string compare time:', a)
end
function B:OnCLE_B(e, ...)
  if e == 'SWING_DAMAGE' or e == 'SPELL_DAMAGE' or e == 'SPELL_PERIODIC_DAMAGE' or e == 'SPELL_BUILDING_DAMAGE' then
    local amt, overkill, _, _, bl, abs, critical = ...
  end
end